package javax.management.relation;

import java.util.Map;
import javax.management.ObjectName;
import java.util.List;

public interface Relation
{
    public abstract List<ObjectName> getRole(String p0) throws IllegalArgumentException, RoleNotFoundException, RelationServiceNotRegisteredException;
    
    public abstract RoleResult getRoles(String[] p0) throws IllegalArgumentException, RelationServiceNotRegisteredException;
    
    public abstract Integer getRoleCardinality(String p0) throws IllegalArgumentException, RoleNotFoundException;
    
    public abstract RoleResult getAllRoles() throws RelationServiceNotRegisteredException;
    
    public abstract RoleList retrieveAllRoles();
    
    public abstract void setRole(Role p0) throws IllegalArgumentException, RoleNotFoundException, RelationTypeNotFoundException, InvalidRoleValueException, RelationServiceNotRegisteredException, RelationNotFoundException;
    
    public abstract RoleResult setRoles(RoleList p0) throws IllegalArgumentException, RelationServiceNotRegisteredException, RelationTypeNotFoundException, RelationNotFoundException;
    
    public abstract void handleMBeanUnregistration(ObjectName p0, String p1) throws IllegalArgumentException, RoleNotFoundException, InvalidRoleValueException, RelationServiceNotRegisteredException, RelationTypeNotFoundException, RelationNotFoundException;
    
    public abstract Map<ObjectName, List<String>> getReferencedMBeans();
    
    public abstract String getRelationTypeName();
    
    public abstract ObjectName getRelationServiceName();
    
    public abstract String getRelationId();
}
